Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7418)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7419)
@@ -37,4 +37,5 @@
   [StorableClass]
   public sealed class GeneralizedQuadraticAssignmentProblem : SingleObjectiveHeuristicOptimizationProblem<IGQAPEvaluator, IGQAPSolutionCreator>, IStorableContent {
+
     public override Image ItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Type; }
@@ -42,4 +43,18 @@
 
     public string Filename { get; set; }
+
+    #region Parameter Descriptions
+    public static readonly string MaximizationDescription = "False if the fitness function should be minimized (default) or otherwise True if it should be maximized.";
+    public static readonly string WeightsDescription = "The weights matrix describes the flows between the equipments.";
+    public static readonly string DistancesDescription = "The distances matrix describes the distances between the locations at which the equipment can be installed.";
+    public static readonly string InstallationCostsDescription = "The installation costs matrix describes the installation costs of installing equipment i at location j";
+    public static readonly string DemandsDescription = "The demands vector describes the space requirements of the equipments.";
+    public static readonly string CapacitiesDescription = "The capacities vector describes the available space at the locations.";
+    public static readonly string TransportationCostsDescription = "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already.";
+    public static readonly string OverbookedCapacityPenaltyDescription = "The multiplier for the constraint violation when added to the quality.";
+    public static readonly string BestKnownSolutionDescription = "The best known solution (if available)";
+    public static readonly string EquipmentNamesDescription = "Optional: A list of names that describes the equipments.";
+    public static readonly string LocationNamesDescription = "Optional: A list of names that describes the locations.";
+    #endregion
 
     #region Parameter Properties
@@ -130,14 +145,14 @@
     public GeneralizedQuadraticAssignmentProblem()
       : base(new GQAPEvaluator(), new RandomSolutionCreator()) {
-      Parameters.Add(new ValueParameter<DoubleMatrix>("Weights", "The weights matrix describes the flows between the equipments.", new DoubleMatrix()));
-      Parameters.Add(new ValueParameter<DoubleMatrix>("Distances", "The distances matrix describes the distances between the locations at which the equipment can be installed.", new DoubleMatrix()));
-      Parameters.Add(new ValueParameter<DoubleMatrix>("InstallationCosts", "The installation costs matrix describes the installation costs of installing equipment i at location j", new DoubleMatrix()));
-      Parameters.Add(new FixedValueParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already.", new DoubleValue(1)));
-      Parameters.Add(new FixedValueParameter<DoubleValue>("OverbookedCapacityPenalty", "The multiplier for the constraint violation when added to the quality.", new DoubleValue(1000)));
-      Parameters.Add(new ValueParameter<DoubleArray>("Demands", "The demands vector describes the space requirements of the equipments.", new DoubleArray()));
-      Parameters.Add(new ValueParameter<DoubleArray>("Capacities", "The capacities vector describes the available space at the locations.", new DoubleArray()));
-      Parameters.Add(new OptionalValueParameter<IItem>("BestKnownSolution", "The best known solution (if available)", null));
-      Parameters.Add(new OptionalValueParameter<StringArray>("EquipmentNames", "Optional: A list of names that describes the equipments.", null, false));
-      Parameters.Add(new OptionalValueParameter<StringArray>("LocationNames", "Optional: A list of names that describes the locations.", null, false));
+      Parameters.Add(new ValueParameter<DoubleMatrix>("Weights", WeightsDescription, new DoubleMatrix()));
+      Parameters.Add(new ValueParameter<DoubleMatrix>("Distances", DistancesDescription, new DoubleMatrix()));
+      Parameters.Add(new ValueParameter<DoubleMatrix>("InstallationCosts", InstallationCostsDescription, new DoubleMatrix()));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("TransportationCosts", TransportationCostsDescription, new DoubleValue(1)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("OverbookedCapacityPenalty", OverbookedCapacityPenaltyDescription, new DoubleValue(1000)));
+      Parameters.Add(new ValueParameter<DoubleArray>("Demands", DemandsDescription, new DoubleArray()));
+      Parameters.Add(new ValueParameter<DoubleArray>("Capacities", CapacitiesDescription, new DoubleArray()));
+      Parameters.Add(new OptionalValueParameter<IItem>("BestKnownSolution", BestKnownSolutionDescription, null));
+      Parameters.Add(new OptionalValueParameter<StringArray>("EquipmentNames", EquipmentNamesDescription, null, false));
+      Parameters.Add(new OptionalValueParameter<StringArray>("LocationNames", LocationNamesDescription, null, false));
 
       WeightsParameter.ReactOnValueToStringChangedAndValueItemImageChanged = false;
@@ -223,108 +238,89 @@
 
     private void Parameterize() {
-      Evaluator.WeightsParameter.ActualName = WeightsParameter.Name;
-      Evaluator.DistancesParameter.ActualName = DistancesParameter.Name;
-      Evaluator.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
-      Evaluator.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
-      Evaluator.DemandsParameter.ActualName = DemandsParameter.Name;
-      Evaluator.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-      Evaluator.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-
-      SolutionCreator.DemandsParameter.ActualName = DemandsParameter.Name;
-      SolutionCreator.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-
-      foreach (var op in Operators.OfType<IEquipmentAwareGQAPOperator>()) {
+
+      var operators = Operators.Union(new IOperator[] { SolutionCreator, Evaluator }).ToArray();
+
+      foreach (var op in operators.OfType<IAssignmentAwareGQAPOperator>()) {
+        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+      }
+      foreach (var op in operators.OfType<IAssignmentsAwareGQAPOperator>()) {
+        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+      }
+      foreach (var op in operators.OfType<IBestKnownQualityAwareGQAPOperator>()) {
+        op.BestKnownQualityParameter.ActualName = BestKnownQualityParameter.Name;
+      }
+      foreach (var op in operators.OfType<IBestKnownSolutionAwareGQAPOperator>()) {
+        op.BestKnownSolutionParameter.ActualName = BestKnownSolutionParameter.Name;
+      }
+      foreach (var op in operators.OfType<ICapacitiesAwareGQAPOperator>()) {
+        op.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
+      }
+      foreach (var op in operators.OfType<IDemandsAwareGQAPOperator>()) {
         op.DemandsParameter.ActualName = DemandsParameter.Name;
       }
-      foreach (var op in Operators.OfType<IGQAPCrossover>()) {
+      foreach (var op in operators.OfType<IDistancesAwareGQAPOperator>()) {
+        op.DistancesParameter.ActualName = DistancesParameter.Name;
+      }
+      foreach (var op in operators.OfType<IEquipmentNamesAwareGQAPOperator>()) {
+        op.EquipmentNamesParameter.ActualName = EquipmentNamesParameter.Name;
+      }
+      foreach (var op in operators.OfType<IGQAPCrossover>()) {
         op.ParentsParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
         op.ChildParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
       }
-      foreach (var op in Operators.OfType<IGQAPEvaluationOperator>()) {
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-        op.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
+      foreach (var op in operators.OfType<IInstallationCostsAwareGQAPOperator>()) {
+        op.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
+      }
+      foreach (var op in operators.OfType<ILocationNamesAwareGQAPOperator>()) {
+        op.LocationNamesParameter.ActualName = LocationNamesParameter.Name;
+      }
+      var moveEvaluator = operators.OfType<IGQAPMoveEvaluator>().FirstOrDefault();
+      foreach (var op in operators.OfType<IGQAPMoveEvaluator>()) { // synchronize all move evaluators
+        if (moveEvaluator != null) {
+          op.MoveQualityParameter.ActualName = moveEvaluator.MoveQualityParameter.ActualName;
+          op.MoveFlowDistanceQualityParameter.ActualName = moveEvaluator.MoveFlowDistanceQualityParameter.ActualName;
+          op.MoveInstallationQualityParameter.ActualName = moveEvaluator.MoveInstallationQualityParameter.ActualName;
+          op.MoveOverbookedCapacityParameter.ActualName = moveEvaluator.MoveOverbookedCapacityParameter.ActualName;
+        }
+      }
+      foreach (var op in operators.OfType<IMoveQualityAwareGQAPOperator>()) {
+        if (moveEvaluator != null) {
+          op.MoveQualityParameter.ActualName = moveEvaluator.MoveQualityParameter.ActualName;
+          op.MoveFlowDistanceQualityParameter.ActualName = moveEvaluator.MoveFlowDistanceQualityParameter.ActualName;
+          op.MoveInstallationQualityParameter.ActualName = moveEvaluator.MoveInstallationQualityParameter.ActualName;
+          op.MoveOverbookedCapacityParameter.ActualName = moveEvaluator.MoveOverbookedCapacityParameter.ActualName;
+        }
+        op.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      }
+      foreach (var op in operators.OfType<IOverbookedCapacityPenaltyAwareGQAPOperator>()) {
         op.OverbookedCapacityPenaltyParameter.ActualName = OverbookedCapacityPenaltyParameter.Name;
-        op.WeightsParameter.ActualName = WeightsParameter.Name;
-        op.DistancesParameter.ActualName = DistancesParameter.Name;
-        op.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
-        op.DemandsParameter.ActualName = DemandsParameter.Name;
-        op.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-      }
-      foreach (var op in Operators.OfType<IGQAPLocalImprovementOperator>()) {
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+      }
+      foreach (var op in operators.OfType<IQualitiesAwareGQAPOperator>()) {
         op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
         op.FlowDistanceQualityParameter.ActualName = Evaluator.FlowDistanceQualityParameter.ActualName;
         op.InstallationQualityParameter.ActualName = Evaluator.InstallationQualityParameter.ActualName;
         op.OverbookedCapacityParameter.ActualName = Evaluator.OverbookedCapacityParameter.ActualName;
+        op.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      }
+      foreach (var op in operators.OfType<IQualityAwareGQAPOperator>()) {
+        op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        op.FlowDistanceQualityParameter.ActualName = Evaluator.FlowDistanceQualityParameter.ActualName;
+        op.InstallationQualityParameter.ActualName = Evaluator.InstallationQualityParameter.ActualName;
+        op.OverbookedCapacityParameter.ActualName = Evaluator.OverbookedCapacityParameter.ActualName;
+        op.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      }
+      foreach (var op in operators.OfType<ITransportationCostsAwareGQAPOperator>()) {
         op.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
-        op.OverbookedCapacityPenaltyParameter.ActualName = OverbookedCapacityPenaltyParameter.Name;
+      }
+      foreach (var op in operators.OfType<IWeightsAwareGQAPOperator>()) {
         op.WeightsParameter.ActualName = WeightsParameter.Name;
-        op.DistancesParameter.ActualName = DistancesParameter.Name;
-        op.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
-        op.DemandsParameter.ActualName = DemandsParameter.Name;
-        op.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-      }
-      foreach (var op in Operators.OfType<IGQAPManipulator>()) {
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-      }
-      foreach (var op in Operators.OfType<IGQAPMerger>()) {
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-        op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
-        op.MaximizationParameter.ActualName = MaximizationParameter.Name;
-      }
-      foreach (var op in Operators.OfType<IGQAPMoveOperator>()) {
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-      }
-      foreach (var op in Operators.OfType<ILocationAwareGQAPOperator>()) {
-        op.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-      }
-
-      foreach (var op in Operators.OfType<IIntegerVectorCrossover>()) {
+      }
+
+      foreach (var op in operators.OfType<IIntegerVectorCrossover>()) {
         op.ParentsParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
         op.ChildParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
       }
-      foreach (var op in Operators.OfType<IIntegerVectorManipulator>()) {
+      foreach (var op in operators.OfType<IIntegerVectorManipulator>()) {
         op.IntegerVectorParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-      }
-
-      if (BestSolutionAnalyzer != null) {
-        BestSolutionAnalyzer.MaximizationParameter.ActualName = MaximizationParameter.Name;
-        BestSolutionAnalyzer.DistancesParameter.ActualName = DistancesParameter.Name;
-        BestSolutionAnalyzer.WeightsParameter.ActualName = WeightsParameter.Name;
-        BestSolutionAnalyzer.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
-        BestSolutionAnalyzer.DemandsParameter.ActualName = DemandsParameter.Name;
-        BestSolutionAnalyzer.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-        BestSolutionAnalyzer.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
-        BestSolutionAnalyzer.OverbookedCapacityPenaltyParameter.ActualName = OverbookedCapacityPenaltyParameter.Name;
-        BestSolutionAnalyzer.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-        BestSolutionAnalyzer.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
-        BestSolutionAnalyzer.FlowDistanceQualityParameter.ActualName = Evaluator.FlowDistanceQualityParameter.ActualName;
-        BestSolutionAnalyzer.InstallationQualityParameter.ActualName = Evaluator.InstallationQualityParameter.ActualName;
-        BestSolutionAnalyzer.OverbookedCapacityParameter.ActualName = Evaluator.OverbookedCapacityParameter.ActualName;
-        BestSolutionAnalyzer.ResultsParameter.ActualName = "Results";
-        BestSolutionAnalyzer.BestKnownQualityParameter.ActualName = BestKnownQualityParameter.Name;
-        BestSolutionAnalyzer.BestKnownSolutionParameter.ActualName = BestKnownSolutionParameter.Name;
-        BestSolutionAnalyzer.EquipmentNamesParameter.ActualName = EquipmentNamesParameter.Name;
-        BestSolutionAnalyzer.LocationNamesParameter.ActualName = LocationNamesParameter.Name;
-      }
-      if (SolutionArchiveAnalyzer != null) {
-        SolutionArchiveAnalyzer.MaximizationParameter.ActualName = MaximizationParameter.Name;
-        SolutionArchiveAnalyzer.DistancesParameter.ActualName = DistancesParameter.Name;
-        SolutionArchiveAnalyzer.WeightsParameter.ActualName = WeightsParameter.Name;
-        SolutionArchiveAnalyzer.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
-        SolutionArchiveAnalyzer.DemandsParameter.ActualName = DemandsParameter.Name;
-        SolutionArchiveAnalyzer.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-        SolutionArchiveAnalyzer.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
-        SolutionArchiveAnalyzer.OverbookedCapacityPenaltyParameter.ActualName = OverbookedCapacityPenaltyParameter.Name;
-        SolutionArchiveAnalyzer.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-        SolutionArchiveAnalyzer.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
-        SolutionArchiveAnalyzer.FlowDistanceQualityParameter.ActualName = Evaluator.FlowDistanceQualityParameter.ActualName;
-        SolutionArchiveAnalyzer.InstallationQualityParameter.ActualName = Evaluator.InstallationQualityParameter.ActualName;
-        SolutionArchiveAnalyzer.OverbookedCapacityParameter.ActualName = Evaluator.OverbookedCapacityParameter.ActualName;
-        SolutionArchiveAnalyzer.ResultsParameter.ActualName = "Results";
-        SolutionArchiveAnalyzer.BestKnownQualityParameter.ActualName = BestKnownQualityParameter.Name;
-        SolutionArchiveAnalyzer.BestKnownSolutionParameter.ActualName = BestKnownSolutionParameter.Name;
-        SolutionArchiveAnalyzer.EquipmentNamesParameter.ActualName = EquipmentNamesParameter.Name;
-        SolutionArchiveAnalyzer.LocationNamesParameter.ActualName = LocationNamesParameter.Name;
       }
     }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 7418)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 7419)
@@ -99,12 +99,23 @@
     <Compile Include="GQAPIntegerVectorProximityCalculator.cs" />
     <Compile Include="GQAPSolution.cs" />
-    <Compile Include="Interfaces\IGQAPMerger.cs" />
+    <Compile Include="Interfaces\IQualitiesAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IAssignmentsAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IBestKnownQualityAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IBestKnownSolutionAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\ILocationNamesAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IEquipmentNamesAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IMoveQualityAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IGQAPEvaluator.cs" />
+    <Compile Include="Interfaces\IQualityAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IOverbookedCapacityPenaltyAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\ITransportationCostsAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IInstallationCostsAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IDistancesAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IWeightsAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IAssignmentAwareGQAPOperator.cs" />
     <Compile Include="Interfaces\IGQAPNMoveEvaluator.cs" />
-    <Compile Include="Interfaces\IEquipmentAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IDemandsAwareGQAPOperator.cs" />
     <Compile Include="Interfaces\IGQAPCrossover.cs" />
-    <Compile Include="Interfaces\IGQAPEvaluationOperator.cs" />
-    <Compile Include="Interfaces\IGQAPEvaluator.cs" />
     <Compile Include="Interfaces\IGQAPLocalImprovementOperator.cs" />
-    <Compile Include="Interfaces\IGQAPManipulator.cs" />
     <Compile Include="Interfaces\IGQAPMoveEvaluator.cs" />
     <Compile Include="Interfaces\IGQAPMoveOperator.cs" />
@@ -112,5 +123,5 @@
     <Compile Include="Interfaces\IGQAPOperator.cs" />
     <Compile Include="Interfaces\IGQAPSolutionCreator.cs" />
-    <Compile Include="Interfaces\ILocationAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\ICapacitiesAwareGQAPOperator.cs" />
     <Compile Include="Moves\NMove.cs" />
     <Compile Include="Moves\GQAPMoveGenerator.cs" />
@@ -120,4 +131,5 @@
     <Compile Include="Moves\StochasticNMoveSingleMoveGenerator.cs" />
     <Compile Include="Operators\ApproximateLocalSearch.cs" />
+    <Compile Include="Operators\GQAPPathRelinking.cs" />
     <Compile Include="Operators\GQAPStochasticSolutionCreator.cs" />
     <Compile Include="Operators\DemandEquivalentSwapEquipmentManipluator.cs" />
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IAssignmentAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IAssignmentAwareGQAPOperator.cs	(revision 7419)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IAssignmentAwareGQAPOperator.cs	(revision 7419)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IAssignmentAwareGQAPOperator : IGQAPOperator {
+    ILookupParameter<IntegerVector> AssignmentParameter { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IAssignmentsAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IAssignmentsAwareGQAPOperator.cs	(revision 7419)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IAssignmentsAwareGQAPOperator.cs	(revision 7419)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IAssignmentsAwareGQAPOperator : IGQAPOperator {
+    IScopeTreeLookupParameter<IntegerVector> AssignmentParameter { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IBestKnownQualityAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IBestKnownQualityAwareGQAPOperator.cs	(revision 7419)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IBestKnownQualityAwareGQAPOperator.cs	(revision 7419)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IBestKnownQualityAwareGQAPOperator : IGQAPOperator {
+    ILookupParameter<DoubleValue> BestKnownQualityParameter { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IBestKnownSolutionAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IBestKnownSolutionAwareGQAPOperator.cs	(revision 7419)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IBestKnownSolutionAwareGQAPOperator.cs	(revision 7419)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IBestKnownSolutionAwareGQAPOperator : IGQAPOperator {
+    ILookupParameter<IntegerVector> BestKnownSolutionParameter { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/ICapacitiesAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/ICapacitiesAwareGQAPOperator.cs	(revision 7419)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/ICapacitiesAwareGQAPOperator.cs	(revision 7419)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface ICapacitiesAwareGQAPOperator : IGQAPOperator {
+    ILookupParameter<DoubleArray> CapacitiesParameter { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IDemandsAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IDemandsAwareGQAPOperator.cs	(revision 7419)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IDemandsAwareGQAPOperator.cs	(revision 7419)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IDemandsAwareGQAPOperator : IGQAPOperator {
+    ILookupParameter<DoubleArray> DemandsParameter { get; }
+  }
+}
